summaryrefslogtreecommitdiff
path: root/test
diff options
context:
space:
mode:
authorMartin Pitt <martin.pitt@ubuntu.com>2016-11-24 11:29:42 +0100
committerMartin Pitt <martin.pitt@ubuntu.com>2016-11-24 11:46:03 +0100
commit30dc7898d5a0311a88f069e39e7ff552b3fc3190 (patch)
tree059503d5473c879e34cee4047d3765e50e4759e9 /test
parent54abf90a0b188fc95dd7bb23dafcf2f333e379d3 (diff)
downloadsystemd-30dc7898d5a0311a88f069e39e7ff552b3fc3190.tar.gz
tests: add hwdb parsing test
This calls the built "systemd-hwdb update" on the source tree's hwdb/ in a temporary directory and verifies that there are no error messages.
Diffstat (limited to 'test')
-rwxr-xr-xtest/hwdb-test.sh43
1 files changed, 43 insertions, 0 deletions
diff --git a/test/hwdb-test.sh b/test/hwdb-test.sh
new file mode 100755
index 0000000000..4638328059
--- /dev/null
+++ b/test/hwdb-test.sh
@@ -0,0 +1,43 @@
+#!/bin/sh
+# call built systemd-hwdb update on our hwdb files to ensure that they parse
+# without error
+#
+# (C) 2016 Canonical Ltd.
+# Author: Martin Pitt <martin.pitt@ubuntu.com>
+#
+# systemd is free software; you can redistribute it and/or modify it
+# under the terms of the GNU Lesser General Public License as published by
+# the Free Software Foundation; either version 2.1 of the License, or
+# (at your option) any later version.
+
+# systemd is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# Lesser General Public License for more details.
+#
+# You should have received a copy of the GNU Lesser General Public License
+# along with systemd; If not, see <http://www.gnu.org/licenses/>.
+
+set -e
+
+ROOTDIR=$(dirname $(dirname $(readlink -f $0)))
+SYSTEMD_HWDB=${builddir:-.}/systemd-hwdb
+
+if [ ! -x "$SYSTEMD_HWDB" ]; then
+ echo "$SYSTEMD_HWDB does not exist, please build first"
+ exit 1
+fi
+
+D=$(mktemp --directory)
+trap "rm -rf '$D'" EXIT INT QUIT PIPE
+mkdir -p "$D/etc/udev"
+ln -s "$ROOTDIR/hwdb" "$D/etc/udev/hwdb.d"
+err=$("$SYSTEMD_HWDB" update --root "$D" 2>&1 >/dev/null)
+if [ -n "$err" ]; then
+ echo "$err"
+ exit 1
+fi
+if [ ! -e "$D/etc/udev/hwdb.bin" ]; then
+ echo "$D/etc/udev/hwdb.bin was not generated"
+ exit 1
+fi